local function OnEvent(self, event, ...)
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	if InCombatLockdown() then --you never know !
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		return
	end

	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)
		if selected then
			EditMacro("t" .. tier, nil, nil, "#showtooltip\n/cast " .. name)
		end
	end
end
local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("PLAYER_TALENT_UPDATE")
frame:RegisterEvent("PLAYER_LOGIN")


SLASH_TALENTMACROS1 = "/talentmacros"
SlashCmdList["TALENTMACROS"] = function()
	local errors = 0
	for tier = 1, MAX_NUM_TALENT_TIERS do
		local name = "t" .. tier
		if GetMacroIndexByName(name) == 0 then
			local success = pcall(CreateMacro, name, "INV_Misc_QuestionMark", "")
			if not success then errors = errors + 1 end
		end
	end
	OnEvent(frame)
	print(errors == 0 and "Macros set!" or errors > 5 and "No free macro slots available!" or ("Unable to create some macros (%d)"):format(errors))
end